/**
 * 
 */
package wifi.rcc;

import android.content.Context;
import android.util.AttributeSet;
import android.view.View;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.view.MotionEvent;

public class VirtualJoyStickView extends View implements StickPositionGetable, Runnable{

	private Paint paint;
	//̶ҡ˱ԲεX,YԼ뾶
	private int RockerCircleX = 190;
	private int RockerCircleY = 210;
	private int RockerCircleR = 120;
	//ҡ˵ĳʼX,Y꼰뾶
	private float SmallRockerInitCircleX =190;
	private float SmallRockerInitCircleY = 210;
	private float SmallRockerInitCircleR = 40;
	//ҡ˵X,YԼҡ˵İ뾶
	private float SmallRockerCircleX = SmallRockerInitCircleX;
	private float SmallRockerCircleY = SmallRockerInitCircleY;
	private float SmallRockerCircleR = SmallRockerInitCircleR;
	
	
	//ػfield
	private Thread Guarder = null;
	private boolean ThreadFlag = false;
	private CarPositionSetable CarToContral = null;

	public VirtualJoyStickView(Context context) {
		super(context);
		init();
	}
	
	public VirtualJoyStickView(Context context, AttributeSet attrs, int defStyle) {
		super(context, attrs, defStyle);
		init();
	}

	public VirtualJoyStickView(Context context, AttributeSet attrs) {
		super(context, attrs);
		init();
	}
	
	public void init()
	{
		this.setKeepScreenOn(true);
		paint = new Paint();
		paint.setAntiAlias(true);
		setFocusable(true);
		setFocusableInTouchMode(true);
	}

	/***
	 * õ֮Ļ
	 */
	public double getRad(float px1, float py1, float px2, float py2) {
		//õXľ
		float x = px2 - px1;
		//õYľ
		float y = py1 - py2;
		//б߳
		float xie = (float) Math.sqrt(Math.pow(x, 2) + Math.pow(y, 2));
		//õǶȵֵͨǺеĶ ڱ/б=Ƕֵ
		float cosAngle = x / xie;
		//ͨҶȡǶȵĻ
		float rad = (float) Math.acos(cosAngle);
		//ע⣺λY<ҡ˵YҪȡֵ-0~-180
		if (py2 < py1) {
			rad = -rad;
		}
		return rad;
	}

	@Override
	public boolean onTouchEvent(MotionEvent event) {
		if (event.getAction() == MotionEvent.ACTION_DOWN || event.getAction() == MotionEvent.ACTION_MOVE) {
			// ڻΧ
			if (Math.sqrt(Math.pow((RockerCircleX - (int) event.getX()), 2) + Math.pow((RockerCircleY - (int) event.getY()), 2)) >= RockerCircleR) {
				//õҡ봥γɵĽǶ
				double tempRad = getRad(RockerCircleX, RockerCircleY, event.getX(), event.getY());
				//֤ڲСԲ˶ĳ
				getXY(RockerCircleX, RockerCircleY, RockerCircleR, tempRad);
			} else {//СĵСڻûƶ
				SmallRockerCircleX = (int) event.getX();
				SmallRockerCircleY = (int) event.getY();
			}
		} else if (event.getAction() == MotionEvent.ACTION_UP) {
			//ͷŰʱҡҪָҡ˵λΪʼλ
			SmallRockerCircleX = SmallRockerInitCircleX;
			SmallRockerCircleY = SmallRockerInitCircleY;
		}
		this.invalidate();
		return true;
	}

	/**
	 * 
	 * @param R
	 *            Բ˶ת
	 * @param centerX
	 *            תX
	 * @param centerY
	 *            תY
	 * @param rad
	 *            תĻ
	 */
	public void getXY(float centerX, float centerY, float R, double rad) {
		//ȡԲ˶X 
		SmallRockerCircleX = (float) (R * Math.cos(rad)) + centerX;
		//ȡԲ˶Y
		SmallRockerCircleY = (float) (R * Math.sin(rad)) + centerY;
	}

	/* (non-Javadoc)
	 * @see android.view.View#onDraw(android.graphics.Canvas)
	 */
	@Override
	protected void onDraw(Canvas canvas) {
		super.onDraw(canvas);
		
		try {
			//canvas.drawColor(Color.WHITE);
			//͸
			paint.setColor(0x70808080);
			//ҡ˱
			canvas.drawCircle(RockerCircleX, RockerCircleY, RockerCircleR, paint);
			paint.setColor(0x70ff0000);
			//ҡ
			canvas.drawCircle(SmallRockerCircleX, SmallRockerCircleY, SmallRockerCircleR, paint);
		} catch (Exception e) {
		} 
	}

	@Override
	public double getX() {
		double temp;
		if(SmallRockerCircleX == SmallRockerInitCircleX)
			return 0;
		temp = SmallRockerCircleX - SmallRockerInitCircleX;
		temp = temp/RockerCircleR;
		return temp;
	}

	@Override
	public double getY() {
		double temp;
		if(SmallRockerCircleY == SmallRockerInitCircleY)
			return 0;
		temp = SmallRockerCircleY - SmallRockerInitCircleY;
		temp = temp/RockerCircleR*(-1);
		return temp;
	}

	/**
	 * ʱλ״̬ػ̶
	 */
	@Override
	public void run() {
		while (ThreadFlag) {
			if(!CarToContral.isBonded())
			{
				CarToContral.Connect();
			}
			CarToContral.setPositionTurn(this.getX());
			try {
				Thread.sleep(50);
			} catch (Exception ex) {
			}
			CarToContral.setPositionMove(this.getY());
			try {
				Thread.sleep(50);
			} catch (Exception ex) {
			}
		}
	}
	
	/**
	 * ڶʱλ״̬ػ
	 */
	public void ThreadCreate()
	{
		if(Guarder != null)  //ȷֻһػ̿Ա
			return;
		Guarder = new Thread(this);
		ThreadFlag = true;
		Guarder.start();
	}
	
	/**
	 * ػ
	 */
	public void ThreadDestory()
	{
		ThreadFlag = false;
		Guarder = null;		
	}
	
	/**
	 * ػλ״̬
	 * @param in
	 */
	public void setPositionSetable(CarPositionSetable in)
	{
		CarToContral = in;
	}
	

	
}
