/**
 * 
 */
package wifi.rcc;

/**
 * @author lynx@ynu  2011/10/15
 *
 */
public interface StickPositionGetable {
	
	/**
	 * Get the X position percent of the max distance.
	 * @return The position X from -1 to 1 in double
	 */
	public double getX();
	
	/**
	 * Get the Y position percent of the max distance.
	 * @return The position Y from -1 to 1 in double
	 */
	public double getY();
	
}
